require 'dl'

$libm = ARGV[0] || "/lib/libm.so"

h = DL.dlopen($libm)
sin = DL::CFunc.new(h['sin'], DL::TYPE_DOUBLE, 'sin')
p sin
r = sin.call([3.14/2].pack("d").unpack("ll"))
print("sin(3.14/2) = #{r}\n")

s = "abc"
ptr = [s].pack("p").unpack("L")[0]
s2 = DL.dlwrap(ptr)
s3 = DL.dlwrap(ptr,s.size + 1)
print("s = #{s.inspect}, s2 = #{s2.inspect}, s3 = #{s3.inspect}\n")
